--[[ 
Example of writing encrypted password into file.
Key string for AES encryption is stored in same folder in binary file named key.bin
AES encrypted and then base64 encoded passwords stored each in sequentially indexed file in same folder
]]

require('strings')

function main ()
   Data ='secret'
   local FileNameExt = '.bin'
   local fPath = 'c:\\temp\\pwdOut\\'
   local fn=nextFileName(fPath,FileNameExt)
   local Key = readBinary(fPath..'key'..FileNameExt) 
   local Base64Encoded = encPassword(Data,Key)
   
   writeBinary(fn,Base64Encoded)
end


function writeBinary(fn,binData)
   local f = io.open(fn, "wb")
   f:write(binData)
   f:close()   
end


function readBinary(fn)
   local f = io.open(fn, "rb")
   if (f) then
      local s=f:read("*all") 
      f:close()   
      return s
   end
end


function encPassword(Data,Key)
   local Data = Data or 'myPassword'
   local AesEncrypted = filter.aes.enc{data=Data,key=Key}
   return  filter.base64.enc(AesEncrypted)
end


function nextFileName(fPath,FileNameExt)
   -- configure paths, etc...
   local pwdFileNameSuffix = '_password'
   local FilePattern = '*'..FileNameExt 
   
   local n=5 -- sets number of zeroes to pad in file name. 
   local nameIndex
   
   -- if running on Win then command to use is 'dir /b'
   -- on different os command will be different
   local P = io.popen('dir /b '..fPath..FilePattern)
   local List = P:read('*a')
   
   for k, v in pairs (List:split('\n')) do 
      nameIndex=k
   end
   
   -- enhance file name Index as desired ....
   nameIndex=tostring(nameIndex):zfill(n)
   
   return fPath..tostring(nameIndex)..
   pwdFileNameSuffix..FileNameExt
end


